import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder();

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData(){
        return hamletData;
    }

    public String swapWords(String input, String replace, String replacement){
        Pattern pattern = Pattern.compile("\\w+(\\W+)?");
        Matcher matcher = pattern.matcher(input);
        String result = "";
        while(matcher.find()){
            String word = matcher.group();
            String punctuation = findPunctuation(word);
            if(!word.trim().equals(replace) && !word.trim().equals(replace.toLowerCase())){
                result += word;
            } else{
                result += replacement + punctuation;
            }
        }
        return result.trim();
    }

    public String findPunctuation(String testString) {
        String punctuation = "";

        Pattern pattern1 = Pattern.compile("\\W+");
        Matcher matcher1 = pattern1.matcher(testString);

        if(matcher1.find()){
            punctuation = matcher1.group();
        }
        return punctuation;
    }

    public boolean findName(String input, String name){
        Pattern pattern = Pattern.compile(name);
        Matcher matcher = pattern.matcher(input);

        return matcher.find();
    }
}
